switch-priv-modes:
  switch_modes: false 
  num_switches: 5

priv-mode:
  mode: m

general:
  total_instructions: 1000
  regs_not_use: x1,x2,x0
  custom_trap_handler: false
  code_start_address: 0x80000000
  default_program_exit: false
  delegation: 0x000

isa-instruction-distribution:
  rel_sys: 0
  rel_sys.csr: 0
  rel_rv32i.ctrl: 0
  rel_rv32i.compute: 10
  rel_rv32i.data: 10
  rel_rv32i.fence: 10
  rel_rv64i.compute: 10
  rel_rv64i.data: 10
  rel_rv32m: 10
  rel_rv64m: 10
  rel_rv32a: 10
  rel_rv64a: 10
  rel_rv32f: 0
  rel_rv64f: 0
  rel_rv32d: 0
  rel_rv64d: 0
  rel_rvc.ctrl: 0
  rel_rvc.compute: 10
  rel_rvc.sp: 10
  rel_rvc.data: 10
  rel_rvc.fdata: 0
  rel_rv32c.compute: 10
  rel_rv32c.ctrl: 0
  rel_rv32c.fdata: 0 #Either 32c or 64c
  rel_rv64c.compute: 10
  rel_rv64c.data: 0 #problematic

float-rounding:
  rne: 10
  rtz: 10
  rdn: 10
  rup: 10
  rmm: 10
  dyn: 10

branch-control:
  block-size: 7
  backward-probability: 0.5

recursion-options:
  recursion-enable: false
  recursion-depth: 10
  recursion-calls: 5

access-sections:
  # begin_signature: 0x800900ff,0x800fffff,rw
  begin_signature: 0x80200000,0x80400000,rw #IMPPP use this addr range to prevent misalignments
    #begin_signature: 0x80090000,0x800a0000,rw

#orig 0x80090000,0x800fffff,rw
#0x80ff0000,0x80ffffff,rw
#Store + load stress test:
#Line stride with:
#Multiple random no.(python) of stores to each line with random block offset then 2 loads to same line. 
#Multiple  random no.(python) of stores + (decide randomly to either slri or slli the store value) and then 2 loads 

#NOTE- Check test intention of this new variant
#Cross coverage insertions: branch (bne or beq) after loads ( different access sizes) , branch after store ( involving address)  and store after load ( with different access sizes)
user-functions:
  func1: '{10: "addi sp, sp, -32*REGBYTES;
	       SREG x1,1*REGBYTES(sp);
	       SREG x2,2*REGBYTES(sp);
	       SREG x3,3*REGBYTES(sp);
	       SREG x4,4*REGBYTES(sp);
	       SREG x5,5*REGBYTES(sp);
	       SREG x6,6*REGBYTES(sp);
	       SREG x7,7*REGBYTES(sp);
	       SREG x8,8*REGBYTES(sp);
	       SREG x9,9*REGBYTES(sp);
	       SREG x10,10*REGBYTES(sp);
	       SREG x11,11*REGBYTES(sp);
	       SREG x12,12*REGBYTES(sp);
	       SREG x13,13*REGBYTES(sp);
	       SREG x14,14*REGBYTES(sp);
	       SREG x15,15*REGBYTES(sp);
	       SREG x16,16*REGBYTES(sp);
	       SREG x17,17*REGBYTES(sp);
	       SREG x18,18*REGBYTES(sp);
	       SREG x19,19*REGBYTES(sp);
               SREG x20,20*REGBYTES(sp);
	       SREG x21,21*REGBYTES(sp);
	       SREG x22,22*REGBYTES(sp);
	       SREG x23,23*REGBYTES(sp);
	       SREG x24,24*REGBYTES(sp);
	       SREG x25,25*REGBYTES(sp);
	       SREG x26,26*REGBYTES(sp);
	       SREG x27,27*REGBYTES(sp);
	       SREG x28,28*REGBYTES(sp);
	       SREG x29,29*REGBYTES(sp);
	       SREG x30,30*REGBYTES(sp);
	       SREG x31,31*REGBYTES(sp);
la t0, begin_signature;
li a0, 0x12da;
li a1, 0x24fa;
li a2, 0xaa1c;
li a3, 0x123f;
li a4, 0xcc10;
li a5, 0x0168;
li a6, 0x324f;
li a7,0x55556;
li t1,0;
li s5,0x30;
loop:sd a0,48(t0);
 sd a1,16(t0);
sd a2,24(t0);
sd a3,56(t0);
 lw t2, 4(t0);
 lw t2, 16(t0);
 sd a7, 40(t0);
li a3,0;
li a2,3;
dum4:srli a7, a7, 1;
 sw a7, 52(t0);
 srli a7, a7, 1;
 sd a7, 8(t0);
 slli a7, a7, 1;
 sd a7, 48(t0);
 slli a7, a7, 1;
 sd a7, 56(t0);
 slli a7, a7, 1;
 lw t2, 12(t0);
 lw t2, 48(t0);
 addi a7,a7, 1;
 sd a0,96(t0);
 sd a1,88(t0);
 sd a2,112(t0);
 sd a3,64(t0);
 sd a4,72(t0);
 sd a5,96(t0);
 lw t2, 76(t0);
addi a3,a3,1;
sh a2, 76(t0);
lhu a2, 76(t0);
bne a3,a2, dum4;
 lw t2, 128(t0);
 sd a7, 104(t0);
 slli a7, a7, 1;
 sd a7, 104(t0);
 slli a7, a7, 1;
li a3,0;
li a2,2;
dum2:sd a7, 96(t0);
 srli a7, a7, 1;
 sd a7, 112(t0);
 slli a7, a7, 1;
 lw t2, 112(t0);
 lw t2, 88(t0);
 addi a7,a7, 1;
 sd a0,160(t0);
 sd a1,176(t0);
 sd a2,184(t0);
 sd a3,192(t0);
 lw t2, 164(t0);
 lw t2, 172(t0);
 sd a7, 144(t0);
 srli a7, a7, 1;
 addi a3,a3,1;
 sw a2, 144(t0);
lwu a2, 144(t0);
bne a3,a2, dum2; 
 sd a7, 160(t0);
 slli a7, a7, 1;
 sd a7, 184(t0);
 slli a7, a7, 1;
 sd a7, 152(t0);
li a3,0;
li a2,2;
dum1:slli a7, a7, 1;
 sw a7, 164(t0);
 slli a7, a7, 1;
 lw t2, 120(t0);
 lh t2, 118(t0);
 sh t2, 120(t0);
 lw t2, 180(t0);
lh t2 , 180(t0);
beq t2,a7, loop;
 addi a7,a7, 1;
 sw a0,236(t0);
 sw a1,200(t0);
 sd a2,216(t0);
 sw a3,240(t0);
addi a3,a3,1;
sd a2, 240(t0);
ld a2, 240(t0);
bne a3,a2, dum1;
 sd a4,208(t0);
 sd a5,240(t0);
 lw t2, 252(t0);
sw t2, 256(t0);
 lw t2, 252(t0);
beq t2,a5, loop;
 lw t2, 252(t0);
 sd a7, 240(t0);
li a3,0;
li a2,2;
dum3:srli a7, a7, 1;
 sw a7, 244(t0);
 slli a7, a7, 1;
 sd a7, 304(t0);
 srli a7, a7, 1;
lb   a7 , 304(t0);
beq a7,t0, loop;
 sw a7, 204(t0);
 slli a7, a7, 1;
ld a7, 208(t0);
 sd a7, 216(t0);
 srli a7, a7, 1;
 sd a7, 232(t0);
ld a7, 232(t0);
beq a7,a3, loop;
 slli a7, a7, 1;
 lw t2, 208(t0);
 lw t2, 192(t0);
addi a3,a3,1;
sb a2, 192(t0);
lbu a2, 192(t0);
bne a3,a2, dum3; 
 lw t2, 960(t0);
 ld t2, 992(t0);
li a5,0;
la a4, jump_final1;
sw a4, 0(t0);
lwu a5, 0(t0);
jalr a6, 0(a5);
 srli a7, a7, 1;
 sd a7, 1000(t0);
 srli a7, a7, 1;
 lw t2, 1004(t0);
nop;
jump_final1:sw a7, 996(t0);
 slli a7, a7, 1;
 sw a7, 980(t0);
 srli a7, a7, 1;
 sd a7, 1000(t0);
 srli a7, a7, 1;
 lw t2, 1004(t0);
 lb t2, 1002(t0);
 sb t2, 1004(t0);
 lw t2, 964(t0);
addi a7,a7, 1;
addi t0, t0, 128;
addi t1,t1,1;
bne t1,s5, loop;
LREG x1,1*REGBYTES(sp);
		LREG x2,2*REGBYTES(sp);
		LREG x3,3*REGBYTES(sp);
		LREG x4,4*REGBYTES(sp);
		LREG x5,5*REGBYTES(sp);
		LREG x6,6*REGBYTES(sp);
		LREG x7,7*REGBYTES(sp);
		LREG x8,8*REGBYTES(sp);
		LREG x9,9*REGBYTES(sp);
		LREG x10,10*REGBYTES(sp);
		LREG x11,11*REGBYTES(sp);
		LREG x12,12*REGBYTES(sp);
		LREG x13,13*REGBYTES(sp);
		LREG x14,14*REGBYTES(sp);
		LREG x15,15*REGBYTES(sp);
		LREG x16,16*REGBYTES(sp);
		LREG x17,17*REGBYTES(sp);
		LREG x18,18*REGBYTES(sp);
		LREG x19,19*REGBYTES(sp);
		LREG x20,20*REGBYTES(sp);
		LREG x21,21*REGBYTES(sp);
		LREG x22,22*REGBYTES(sp);
		LREG x23,23*REGBYTES(sp);
		LREG x24,24*REGBYTES(sp);
		LREG x25,25*REGBYTES(sp);
		LREG x26,26*REGBYTES(sp);
		LREG x27,27*REGBYTES(sp);
		LREG x28,28*REGBYTES(sp);
		LREG x29,29*REGBYTES(sp);
		LREG x30,30*REGBYTES(sp);
		LREG x31,31*REGBYTES(sp);
		addi sp, sp, +32*REGBYTES;
" }'

i-cache:
  num_calls: 0
  num_bytes_per_block: 16
  num_blocks: 8
  num_cycles: 10

d-cache:
  num_calls: 0
  num_bytes_per_block: 16
  num_blocks: 8
  num_cycles: 10

exception-generation:
  ecause00: 0
  ecause01: 0
  ecause02: 0
  ecause03: 0
  ecause04: 0
  ecause05: 0
  ecause06: 0
  ecause07: 0
  ecause08: 0
  ecause09: 0
  ecause10: 0
  ecause11: 0
  ecause12: 0
  ecause13: 0
  ecause14: 0

csr-sections:
  sections: 0x000:0xfff

data-hazards:
  raw_prob: 1
  war_prob: 1
  waw_prob: 1
  num_regs_lookbehind: 3

program-macro:
  pre_program_macro: "add x0,x0,x0"
  post_program_macro: "li gp,1; \n sw gp, tohost, t5;\n fence.i;\n li t6,  0x20000; \n la t5, begin_signature; \n sw t5, 0(t6); \n la t5, end_signature \n sw t5, 8(t6); \n sw t5,  12(t6);"        
  pre_branch_macro: "add x0,x0,x0"
  post_branch_macro: "add x0,x0,x0"
  ecause00: "random"
  ecause01: "random"
  ecause02: "random"
  ecause03: "random"
  ecause04: "random"
  ecause05: "random"
  ecause06: "random"
  ecause07: "random"
  ecause08: "random"
  ecause09: "random"
  ecause10: "random"
  ecause11: "random"
  ecause12: "random"
  ecause13: "random"
  ecause14: "random"
